/* q_insert - install Q_NODE at proper place in queue */
#include "queue.h"
void q_insert(frontp, rearp, p, cmpfn)
	Q_NODE **frontp, **rearp;
	Q_NODE *p;
	int (*cmpfn)();				/* function for comparisons */
	{
	Q_NODE *p2;

	if (*frontp == NULL					/* if queue was empty, */
		|| (*cmpfn)(p, *frontp) < 0)	/* or if p comes first, */
		Q_PUSH(frontp, rearp, p);		/* push p onto front */
	else
		{
		for (p2 = *frontp; ; p2 = Q_NEXT(p2))
			{
			if (Q_NEXT(p2) == NULL)			
				{ 							/* if end of queue, */
				Q_APPEND(frontp, rearp, p);	/* append p at rear of queue */
				break;
				}
			else if ((*cmpfn)(p, Q_NEXT(p2)) < 0)
				{						/* if p sorts before Q_NEXT(p2) */
				Q_R_INSERT(frontp, rearp, p, p2);	/* insert after p2 */
				break;
				}
			}
		}
	}
